const server = require('net').createServer();
const sessionId = 1n;
const encryptionSeed = 1324823;

function dec2hex(n) {
	return n ? [n%256].concat(dec2hex(~~(n/256))).slice(0, 4) : [0,0,0,0];
}

const cryptKey = [ 87,2,91,4, 0,0,0,0, 55,10,18,105,65,56,15,120, 27,4,36,34,67,1,73,83,80,5,19,53,79,2,77,5 ];

function MakeCryptKey(num) {
	const bytes = dec2hex(encryptionSeed);
	cryptKey[4] = bytes[0] ^ 52;
	cryptKey[5] = bytes[1] ^ 6;
	cryptKey[6] = bytes[2] ^ 1;
	cryptKey[7] = bytes[3] ^ 8;
}
MakeCryptKey(encryptionSeed);

function sendPacketToClient(data, op, sock) {
	const packet = Buffer.from([...[...Buffer.alloc(26)].concat([...data])]);
	packet.writeUInt32LE(1, 0);
	packet.writeUInt32LE(data.length + 26, 4);
	packet.writeUInt32LE(data.length + 6, 20);
	packet.writeUInt16LE(op, 24);
	packet.writeUInt16LE(op, 16);
	packet.writeUInt16LE(getChecksum(packet), 18);

	sock.write(packet);
}

function Decrypt(buf, index, length) {
	for(let i = 0; i < length; ++i) {
   		let a = buf[index + i] ^ 0xF0;
   		buf[index + i] = (((a >> 2) | ((a & 3) << 6)) ^ cryptKey[i % 32]);
	}

	buf.writeUInt32LE(buf.readUInt32LE(0) & ~8, 0);
	buf.writeUInt16LE(getChecksum([...buf]), 18);
}

function getChecksum(data) {
	const dataBuffer = Buffer.from([...data]);
	let i = 0;
	for(let pos = 20; pos < data.length; pos++) {
		i += dataBuffer.readUInt8(pos);
	}

	let checksumData = i - (data.length + (dataBuffer.readUInt32LE(0) << 29 >> 29));
	return (checksumData + (checksumData >> 16)) & 0xFFFF;
}

server.on('connection', function(socket) {
	console.log('Connection made');
	const _data = Buffer.from([0x00,0x00,0x00,0x10,0x00,0x01,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00]);
	_data.writeBigUint64LE(sessionId, 7);
	_data.writeUInt32LE(encryptionSeed, 15);
	
	sendPacketToClient(_data, 3100, socket);

	socket.on('data', function(data) {
		const opcode = data.readUInt16LE(16);
		if(opcode == 1000) {
			if(((data.readUInt32LE(0) >> 3) & 1) == 1) {
				Decrypt(data, 20, data.length - 20);
			}
			console.log(`>> Login Data received`);
			const body = Buffer.from([...data].slice(26));

			const usernameData = [];
			const userNameRawData = [...body].slice(5, 37);
			for(let i = 0; i < userNameRawData.length; i++) {
				if(userNameRawData[i] != 0x00) {
					usernameData.push(userNameRawData[i]);
				} else if(userNameRawData[i - 1] == 0x00) {
					break;
				}
			}
			const username = Buffer.from(usernameData).toString();

			let password = '';
			const passwordRawData = [...body].slice(47);
			for(let i = 0; i < passwordRawData.length; i++) {
				if(passwordRawData[i] != 0x00) {
					password += String.fromCharCode(passwordRawData[i]);
				} else {
					break;
				}
			}

			console.log(`> Username: ${username}`);
			console.log(`> Password: ${password}`);

			const _data = Buffer.from([0x00,0x11,0x04,0x00,0x00,0x00,0x00]);
			sendPacketToClient(_data, 3110, socket);
		}
	});
	
	socket.on('close', function() {
		console.log('Connection closed\n');
	});
});

server.listen(20100, '0.0.0.0', function() {
	console.log(`Listening for connections on ${server.address().address}:${server.address().port}`);
});
